diff --git a/src/backend/utils/adt/quote.c b/src/backend/utils/adt/quote.c
index a638116..0838851 100644
--- a/src/backend/utils/adt/quote.c
+++ b/src/backend/utils/adt/quote.c
@@ -13,17 +13,9 @@
  */
 #include "postgres.h"
 
-#include <ctype.h>
-
-#include "mb/pg_wchar.h"
 #include "utils/builtins.h"
 
 
-static bool quote_ident_required(text *iptr);
-static text *do_quote_ident(text *iptr);
-static text *do_quote_literal(text *iptr);
-
-
 /*
  * quote_ident -
  *	  returns a properly quoted identifier
@@ -33,16 +25,22 @@ quote_ident(PG_FUNCTION_ARGS)
 {
 	text	   *t = PG_GETARG_TEXT_P(0);
 	text	   *result;
+	const char *qstr;
+	char	   *str;
+	int			len;
 
-	if (quote_ident_required(t))
-		result = do_quote_ident(t);
-	else
-	{
-		result = (text *) palloc(VARSIZE(t));
-		memcpy(result, t, VARSIZE(t));
-	}
+	/* We have to convert to a C string to use quote_identifier */
+	len = VARSIZE(t) - VARHDRSZ;
+	str = (char *) palloc(len + 1);
+	memcpy(str, VARDATA(t), len);
+	str[len] = '\0';
 
-	PG_FREE_IF_COPY(t, 0);
+	qstr = quote_identifier(str);
+
+	len = strlen(qstr);
+	result = (text *) palloc(len + VARHDRSZ);
+	VARATT_SIZEP(result) = len + VARHDRSZ;
+	memcpy(VARDATA(result), qstr, len);
 
 	PG_RETURN_TEXT_P(result);
 }
@@ -56,136 +54,30 @@ quote_literal(PG_FUNCTION_ARGS)
 {
 	text	   *t = PG_GETARG_TEXT_P(0);
 	text	   *result;
-
-	result = do_quote_literal(t);
-
-	PG_FREE_IF_COPY(t, 0);
-
-	PG_RETURN_TEXT_P(result);
-}
-
-/*
- * Check if a given identifier needs quoting
- */
-static bool
-quote_ident_required(text *iptr)
-{
-	char	   *cp;
-	char	   *ep;
-
-	cp = VARDATA(iptr);
-	ep = VARDATA(iptr) + VARSIZE(iptr) - VARHDRSZ;
-
-	if (cp >= ep)
-		return true;
-
-	if (pg_mblen(cp) != 1)
-		return true;
-	if (!(*cp == '_' || (*cp >= 'a' && *cp <= 'z')))
-		return true;
-
-	while ((++cp) < ep)
-	{
-		if (pg_mblen(cp) != 1)
-			return true;
-
-		if (*cp >= 'a' && *cp <= 'z')
-			continue;
-		if (*cp >= '0' && *cp <= '9')
-			continue;
-		if (*cp == '_')
-			continue;
-
-		return true;
-	}
-
-	return false;
-}
-
-/*
- * Return a properly quoted identifier
- */
-static text *
-do_quote_ident(text *iptr)
-{
-	text	   *result;
 	char	   *cp1;
 	char	   *cp2;
 	int			len;
-	int			wl;
 
-	len = VARSIZE(iptr) - VARHDRSZ;
-	result = (text *) palloc(len * 2 + VARHDRSZ + 2);
+	len = VARSIZE(t) - VARHDRSZ;
+	/* We make a worst-case result area; wasting a little space is OK */
+	result = (text *) palloc(len * 2 + 2 + VARHDRSZ);
 
-	cp1 = VARDATA(iptr);
-	cp2 = VARDATA(result);
-
-	*cp2++ = '"';
-	while (len > 0)
-	{
-		if ((wl = pg_mblen(cp1)) != 1)
-		{
-			len -= wl;
-
-			while (wl-- > 0)
-				*cp2++ = *cp1++;
-			continue;
-		}
-
-		if (*cp1 == '"')
-			*cp2++ = '"';
-		*cp2++ = *cp1++;
-
-		len--;
-	}
-	*cp2++ = '"';
-
-	VARATT_SIZEP(result) = cp2 - ((char *) result);
-
-	return result;
-}
-
-/*
- * Return a properly quoted literal value
- */
-static text *
-do_quote_literal(text *lptr)
-{
-	text	   *result;
-	char	   *cp1;
-	char	   *cp2;
-	int			len;
-	int			wl;
-
-	len = VARSIZE(lptr) - VARHDRSZ;
-	result = (text *) palloc(len * 2 + VARHDRSZ + 2);
-
-	cp1 = VARDATA(lptr);
+	cp1 = VARDATA(t);
 	cp2 = VARDATA(result);
 
 	*cp2++ = '\'';
-	while (len > 0)
+	while (len-- > 0)
 	{
-		if ((wl = pg_mblen(cp1)) != 1)
-		{
-			len -= wl;
-
-			while (wl-- > 0)
-				*cp2++ = *cp1++;
-			continue;
-		}
-
 		if (*cp1 == '\'')
 			*cp2++ = '\'';
-		if (*cp1 == '\\')
+		else if (*cp1 == '\\')
 			*cp2++ = '\\';
-		*cp2++ = *cp1++;
 
-		len--;
+		*cp2++ = *cp1++;
 	}
 	*cp2++ = '\'';
 
 	VARATT_SIZEP(result) = cp2 - ((char *) result);
 
-	return result;
+	PG_RETURN_TEXT_P(result);
 }
diff --git a/src/backend/utils/init/postinit.c b/src/backend/utils/init/postinit.c
index 49d29ec..1688b4a 100644
--- a/src/backend/utils/init/postinit.c
+++ b/src/backend/utils/init/postinit.c
@@ -122,9 +122,11 @@ ReverifyMyDatabase(const char *name)
 
 	/*
 	 * Also check that the database is currently allowing connections.
+	 * (We do not enforce this in standalone mode, however, so that there is
+	 * a way to recover from "UPDATE pg_database SET datallowconn = false;")
 	 */
 	dbform = (Form_pg_database) GETSTRUCT(tup);
-	if (!dbform->datallowconn)
+	if (IsUnderPostmaster && !dbform->datallowconn)
 		ereport(FATAL,
 				(errcode(ERRCODE_OBJECT_NOT_IN_PREREQUISITE_STATE),
 		 errmsg("database \"%s\" is not currently accepting connections",
@@ -470,13 +472,15 @@ ShutdownPostgres(int code, Datum arg)
 	 * since that just raises the odds of failure --- but there's some
 	 * stuff we need to do.
 	 *
-	 * Release any LW locks and buffer context locks we might be holding.
-	 * This is a kluge to improve the odds that we won't get into a
-	 * self-made stuck-lock scenario while trying to shut down.
+	 * Release any LW locks, buffer content locks, and buffer pins we might be
+	 * holding.  This is a kluge to improve the odds that we won't get into a
+	 * self-made stuck-lock scenario while trying to shut down.  We *must*
+	 * release buffer pins to make it safe to do file deletion, since we
+	 * might have some pins on pages of the target files.
 	 */
 	LWLockReleaseAll();
-	AbortBufferIO();
-	UnlockBuffers();
+	AtProcExit_Buffers();
+	AtProcExit_LocalBuffers();
 
 	/*
 	 * In case a transaction is open, delete any files it created.	This
diff --git a/src/backend/utils/mb/conversion_procs/Makefile b/src/backend/utils/mb/conversion_procs/Makefile
index fb69fe7..e915fe7 100644
--- a/src/backend/utils/mb/conversion_procs/Makefile
+++ b/src/backend/utils/mb/conversion_procs/Makefile
@@ -157,7 +157,7 @@ ifeq ($(enable_shared), yes)
 		func=$$1; shift; \
 		obj=$$1; shift; \
 		echo "-- $$se --> $$de"; \
-		echo "CREATE OR REPLACE FUNCTION $$func (INTEGER, INTEGER, CSTRING, CSTRING, INTEGER) RETURNS VOID AS '$$"libdir"/$$obj', '$$func' LANGUAGE 'c' STRICT;"; \
+		echo "CREATE OR REPLACE FUNCTION $$func (INTEGER, INTEGER, CSTRING, INTERNAL, INTEGER) RETURNS VOID AS '$$"libdir"/$$obj', '$$func' LANGUAGE 'c' STRICT;"; \
 		echo "DROP CONVERSION pg_catalog.$$name;"; \
 		echo "CREATE DEFAULT CONVERSION pg_catalog.$$name FOR '$$se' TO '$$de' FROM $$func;"; \
 	done > $@
diff --git a/src/backend/utils/mmgr/portalmem.c b/src/backend/utils/mmgr/portalmem.c
index 525ae8f..12fee76 100644
--- a/src/backend/utils/mmgr/portalmem.c
+++ b/src/backend/utils/mmgr/portalmem.c
@@ -416,18 +416,14 @@ DropDependentPortals(MemoryContext queryContext)
  *
  * Any holdable cursors created in this transaction need to be converted to
  * materialized form, since we are going to close down the executor and
- * release locks.  Remove all other portals created in this transaction.
- * Portals remaining from prior transactions should be left untouched.
+ * release locks.  Other portals are not touched yet.
  *
- * XXX This assumes that portals can be deleted in a random order, ie,
- * no portal has a reference to any other (at least not one that will be
- * exercised during deletion).	I think this is okay at the moment, but
- * we've had bugs of that ilk in the past.  Keep a close eye on cursor
- * references...
+ * Returns TRUE if any holdable cursors were processed, FALSE if not.
  */
-void
-AtCommit_Portals(void)
+bool
+CommitHoldablePortals(void)
 {
+	bool result = false;
 	HASH_SEQ_STATUS status;
 	PortalHashEnt *hentry;
 
@@ -437,27 +433,9 @@ AtCommit_Portals(void)
 	{
 		Portal		portal = hentry->portal;
 
-		/*
-		 * Do not touch active portals --- this can only happen in the
-		 * case of a multi-transaction utility command, such as VACUUM.
-		 *
-		 * Note however that any resource owner attached to such a portal is
-		 * still going to go away, so don't leave a dangling pointer.
-		 */
-		if (portal->status == PORTAL_ACTIVE)
-		{
-			portal->resowner = NULL;
-			continue;
-		}
-
-		/*
-		 * Do nothing else to cursors held over from a previous
-		 * transaction.
-		 */
-		if (portal->createSubid == InvalidSubTransactionId)
-			continue;
-
+		/* Is it a holdable portal created in the current xact? */
 		if ((portal->cursorOptions & CURSOR_OPT_HOLD) &&
+			portal->createSubid != InvalidSubTransactionId &&
 			portal->status == PORTAL_READY)
 		{
 			/*
@@ -484,12 +462,60 @@ AtCommit_Portals(void)
 			 * as not belonging to this transaction.
 			 */
 			portal->createSubid = InvalidSubTransactionId;
+
+			result = true;
 		}
-		else
+	}
+
+	return result;
+}
+
+/*
+ * Pre-commit processing for portals.
+ *
+ * Remove all non-holdable portals created in this transaction.
+ * Portals remaining from prior transactions should be left untouched.
+ *
+ * XXX This assumes that portals can be deleted in a random order, ie,
+ * no portal has a reference to any other (at least not one that will be
+ * exercised during deletion).	I think this is okay at the moment, but
+ * we've had bugs of that ilk in the past.  Keep a close eye on cursor
+ * references...
+ */
+void
+AtCommit_Portals(void)
+{
+	HASH_SEQ_STATUS status;
+	PortalHashEnt *hentry;
+
+	hash_seq_init(&status, PortalHashTable);
+
+	while ((hentry = (PortalHashEnt *) hash_seq_search(&status)) != NULL)
+	{
+		Portal		portal = hentry->portal;
+
+		/*
+		 * Do not touch active portals --- this can only happen in the
+		 * case of a multi-transaction utility command, such as VACUUM.
+		 *
+		 * Note however that any resource owner attached to such a portal is
+		 * still going to go away, so don't leave a dangling pointer.
+		 */
+		if (portal->status == PORTAL_ACTIVE)
 		{
-			/* Zap all non-holdable portals */
-			PortalDrop(portal, true);
+			portal->resowner = NULL;
+			continue;
 		}
+
+		/*
+		 * Do nothing to cursors held over from a previous transaction
+		 * (including holdable ones just frozen by CommitHoldablePortals).
+		 */
+		if (portal->createSubid == InvalidSubTransactionId)
+			continue;
+
+		/* Zap all non-holdable portals */
+		PortalDrop(portal, true);
 	}
 }
 
@@ -601,9 +627,11 @@ AtSubCommit_Portals(SubTransactionId mySubid,
 /*
  * Subtransaction abort handling for portals.
  *
- * Deactivate failed portals created during the failed subtransaction.
+ * Deactivate portals created during the failed subtransaction.
  * Note that per AtSubCommit_Portals, this will catch portals created
  * in descendants of the subtransaction too.
+ *
+ * We don't destroy any portals here; that's done in AtSubCleanup_Portals.
  */
 void
 AtSubAbort_Portals(SubTransactionId mySubid,
@@ -628,6 +656,8 @@ AtSubAbort_Portals(SubTransactionId mySubid,
 		 * will go FAILED if the underlying cursor fails.  (Note we do NOT
 		 * want to do this to upper-level portals, since they may be able
 		 * to continue.)
+		 *
+		 * This is only needed to dodge the sanity check in PortalDrop.
 		 */
 		if (portal->status == PORTAL_ACTIVE)
 			portal->status = PORTAL_FAILED;
@@ -635,7 +665,14 @@ AtSubAbort_Portals(SubTransactionId mySubid,
 		/*
 		 * If the portal is READY then allow it to survive into the parent
 		 * transaction; otherwise shut it down.
+		 *
+		 * Currently, we can't actually support that because the portal's
+		 * query might refer to objects created or changed in the failed
+		 * subtransaction, leading to crashes if execution is resumed.
+		 * So, even READY portals are deleted.  It would be nice to detect
+		 * whether the query actually depends on any such object, instead.
 		 */
+#ifdef NOT_USED
 		if (portal->status == PORTAL_READY)
 		{
 			portal->createSubid = parentSubid;
@@ -643,6 +680,7 @@ AtSubAbort_Portals(SubTransactionId mySubid,
 				ResourceOwnerNewParent(portal->resowner, parentXactOwner);
 		}
 		else
+#endif
 		{
 			/* let portalcmds.c clean up the state it knows about */
 			if (PointerIsValid(portal->cleanup))
diff --git a/src/backend/utils/sort/tuplesort.c b/src/backend/utils/sort/tuplesort.c
index a96ade0..3db8fcd 100644
--- a/src/backend/utils/sort/tuplesort.c
+++ b/src/backend/utils/sort/tuplesort.c
@@ -1804,13 +1804,12 @@ myFunctionCall2(FmgrInfo *flinfo, Datum arg1, Datum arg2)
 	FunctionCallInfoData fcinfo;
 	Datum		result;
 
-	/* MemSet(&fcinfo, 0, sizeof(fcinfo)); */
+	fcinfo.flinfo = flinfo;
 	fcinfo.context = NULL;
 	fcinfo.resultinfo = NULL;
 	fcinfo.isnull = false;
-
-	fcinfo.flinfo = flinfo;
 	fcinfo.nargs = 2;
+
 	fcinfo.arg[0] = arg1;
 	fcinfo.arg[1] = arg2;
 	fcinfo.argnull[0] = false;
diff --git a/src/bcc32.mak b/src/bcc32.mak
index d861c92..a2f6c92 100644
--- a/src/bcc32.mak
+++ b/src/bcc32.mak
@@ -29,19 +29,19 @@ ALL:
    if not exist pg_config.h copy pg_config.h.win32 pg_config.h
    cd ..
    cd interfaces\libpq
-   make -DCFG=$(CFG) /f bcc32.mak 
+   make -N -DCFG=$(CFG) /f bcc32.mak 
    cd ..\..\bin\psql
-   make -DCFG=$(CFG) /f bcc32.mak
+   make -N -DCFG=$(CFG) /f bcc32.mak
    cd ..\..
    echo All Win32 parts have been built!
 
 CLEAN:
    cd interfaces\libpq
-   make -DCFG=Release /f bcc32.mak CLEAN
-   make -DCFG=Debug /f bcc32.mak CLEAN
+   make -N -DCFG=Release /f bcc32.mak CLEAN
+   make -N -DCFG=Debug /f bcc32.mak CLEAN
    cd ..\..\bin\psql
-   make -DCFG=Release /f bcc32.mak CLEAN
-   make -DCFG=Debug /f bcc32.mak CLEAN
+   make -N -DCFG=Release /f bcc32.mak CLEAN
+   make -N -DCFG=Debug /f bcc32.mak CLEAN
    cd ..\..
    echo All Win32 parts have been cleaned!
 
diff --git a/src/bin/initdb/Makefile b/src/bin/initdb/Makefile
index 7e27ceb..4ea426f 100644
--- a/src/bin/initdb/Makefile
+++ b/src/bin/initdb/Makefile
@@ -21,7 +21,7 @@ OBJS=	initdb.o $(WIN32RES)
 all: submake-libpq submake-libpgport initdb
 
 initdb: $(OBJS) $(libpq_builddir)/libpq.a
-	$(CC) $(CFLAGS) $(OBJS) $(libpq) $(LDFLAGS) $(LIBS) -o $@$(X)
+	$(CC) $(CFLAGS) $(OBJS) $(libpq_pgport) $(LDFLAGS) $(LIBS) -o $@$(X)
 
 install: all installdirs
 	$(INSTALL_PROGRAM) initdb$(X) $(DESTDIR)$(bindir)/initdb$(X)
diff --git a/src/bin/pg_ctl/Makefile b/src/bin/pg_ctl/Makefile
index a20a8a6..975a226 100644
--- a/src/bin/pg_ctl/Makefile
+++ b/src/bin/pg_ctl/Makefile
@@ -21,7 +21,7 @@ OBJS=	pg_ctl.o $(WIN32RES)
 all: submake-libpq submake-libpgport pg_ctl
 
 pg_ctl: $(OBJS) $(libpq_builddir)/libpq.a
-	$(CC) $(CFLAGS) $(OBJS) $(libpq) $(LDFLAGS) $(LIBS) -o $@$(X)
+	$(CC) $(CFLAGS) $(OBJS) $(libpq_pgport) $(LDFLAGS) $(LIBS) -o $@$(X)
 
 install: all installdirs
 	$(INSTALL_PROGRAM) pg_ctl$(X) $(DESTDIR)$(bindir)/pg_ctl$(X)
diff --git a/src/bin/pg_dump/Makefile b/src/bin/pg_dump/Makefile
index e774f65..d71966c 100644
--- a/src/bin/pg_dump/Makefile
+++ b/src/bin/pg_dump/Makefile
@@ -25,13 +25,13 @@ EXTRA_OBJS = $(top_builddir)/src/backend/parser/keywords.o
 all: submake-libpq submake-libpgport submake-backend pg_dump pg_restore pg_dumpall
 
 pg_dump: pg_dump.o common.o pg_dump_sort.o $(OBJS) $(libpq_builddir)/libpq.a 
-	$(CC) $(CFLAGS) pg_dump.o common.o pg_dump_sort.o $(OBJS) $(EXTRA_OBJS) $(libpq) $(LDFLAGS) $(LIBS) -o $@$(X)
+	$(CC) $(CFLAGS) pg_dump.o common.o pg_dump_sort.o $(OBJS) $(EXTRA_OBJS) $(libpq_pgport) $(LDFLAGS) $(LIBS) -o $@$(X)
 
 pg_restore: pg_restore.o $(OBJS) $(libpq_builddir)/libpq.a
-	$(CC) $(CFLAGS) pg_restore.o $(OBJS) $(EXTRA_OBJS) $(libpq) $(LDFLAGS) $(LIBS) -o $@$(X)
+	$(CC) $(CFLAGS) pg_restore.o $(OBJS) $(EXTRA_OBJS) $(libpq_pgport) $(LDFLAGS) $(LIBS) -o $@$(X)
 
 pg_dumpall: pg_dumpall.o dumputils.o $(libpq_builddir)/libpq.a
-	$(CC) $(CFLAGS) pg_dumpall.o dumputils.o $(EXTRA_OBJS) $(WIN32RES) $(libpq) $(LDFLAGS) $(LIBS) -o $@$(X)
+	$(CC) $(CFLAGS) pg_dumpall.o dumputils.o $(EXTRA_OBJS) $(WIN32RES) $(libpq_pgport) $(LDFLAGS) $(LIBS) -o $@$(X)
 
 .PHONY: submake-backend
 submake-backend:
diff --git a/src/bin/pg_dump/dumputils.c b/src/bin/pg_dump/dumputils.c
index e4221ac..4be925c 100644
--- a/src/bin/pg_dump/dumputils.c
+++ b/src/bin/pg_dump/dumputils.c
@@ -160,7 +160,7 @@ appendStringLiteralDQ(PQExpBuffer buf, const char *str, const char *dqprefix)
 	/* start with $ + dqprefix if not NULL */
 	appendPQExpBufferChar(delimBuf, '$');
 	if (dqprefix)
-		appendPQExpBuffer(delimBuf, dqprefix);
+		appendPQExpBufferStr(delimBuf, dqprefix);
 
 	/*
 	 * Make sure we choose a delimiter which (without the trailing $) is
diff --git a/src/bin/pg_dump/nls.mk b/src/bin/pg_dump/nls.mk
index c293974..04a53f0 100644
--- a/src/bin/pg_dump/nls.mk
+++ b/src/bin/pg_dump/nls.mk
@@ -1,6 +1,6 @@
 # $PostgreSQL$
 CATALOG_NAME	:= pg_dump
-AVAIL_LANGUAGES	:= cs de es fr it nb pt_BR ro ru sk sl sv tr zh_CN zh_TW
+AVAIL_LANGUAGES	:= cs de es fr it ko nb pt_BR ro ru sk sl sv tr zh_CN zh_TW
 GETTEXT_FILES	:= pg_dump.c common.c pg_backup_archiver.c pg_backup_custom.c \
                    pg_backup_db.c pg_backup_files.c pg_backup_null.c \
                    pg_backup_tar.c pg_restore.c pg_dumpall.c \
diff --git a/src/bin/pg_dump/pg_dump_sort.c b/src/bin/pg_dump/pg_dump_sort.c
index 4810be9..5b1dcf4 100644
--- a/src/bin/pg_dump/pg_dump_sort.c
+++ b/src/bin/pg_dump/pg_dump_sort.c
@@ -30,7 +30,7 @@ static const int oldObjectTypePriority[] =
 	1,							/* DO_NAMESPACE */
 	2,							/* DO_TYPE */
 	2,							/* DO_FUNC */
-	2,							/* DO_AGG */
+	3,							/* DO_AGG */
 	3,							/* DO_OPERATOR */
 	4,							/* DO_OPCLASS */
 	5,							/* DO_CONVERSION */
diff --git a/src/bin/pg_dump/pg_restore.c b/src/bin/pg_dump/pg_restore.c
index 3ffa3e9..71f937e 100644
--- a/src/bin/pg_dump/pg_restore.c
+++ b/src/bin/pg_dump/pg_restore.c
@@ -314,7 +314,7 @@ main(int argc, char **argv)
 				break;
 
 			default:
-				write_msg("unrecognized archive format '%s'; please specify 't' or 'c'\n",
+				write_msg(NULL, "unrecognized archive format '%s'; please specify 't' or 'c'\n",
 						  opts->formatName);
 				exit(1);
 		}
diff --git a/src/bin/psql/Makefile b/src/bin/psql/Makefile
index 9934d95..1b214bd 100644
--- a/src/bin/psql/Makefile
+++ b/src/bin/psql/Makefile
@@ -29,7 +29,7 @@ FLEXFLAGS = -Cfe
 all: submake-libpq submake-libpgport psql
 
 psql: $(OBJS) $(libpq_builddir)/libpq.a
-	$(CC) $(CFLAGS) $(OBJS) $(libpq) $(LDFLAGS) $(LIBS) -o $@$(X)
+	$(CC) $(CFLAGS) $(OBJS) $(libpq_pgport) $(LDFLAGS) $(LIBS) -o $@$(X)
 
 help.o: $(srcdir)/sql_help.h
 
diff --git a/src/bin/psql/bcc32.mak b/src/bin/psql/bcc32.mak
index 60a2b69..98bd404 100644
--- a/src/bin/psql/bcc32.mak
+++ b/src/bin/psql/bcc32.mak
@@ -1,6 +1,17 @@
 # Makefile for Borland C++ 5.5
+
 # Borland C++ base install directory goes here
-# BCB=d:\Borland\Bcc55
+# BCB=c:\Borland\Bcc55
+
+!IF "$(BCB)" == ""
+!MESSAGE You must edit bcc32.mak and define BCB at the top
+!ERROR missing BCB
+!ENDIF
+
+!IF "$(__NMAKE__)" == ""
+!MESSAGE You must use the -N compatibility flag, e.g. make -N -f bcc32.make
+!ERROR missing -N
+!ENDIF
 
 !MESSAGE Building PSQL.EXE ...
 !MESSAGE
@@ -19,7 +30,7 @@ CFG=Release
 !MESSAGE You can specify a configuration when running MAKE
 !MESSAGE by defining the macro CFG on the command line. For example:
 !MESSAGE
-!MESSAGE make  -DCFG=[Release | Debug] /f bcc32.mak
+!MESSAGE make -N -DCFG=[Release | Debug] -f bcc32.mak
 !MESSAGE
 !MESSAGE Possible choices for configuration are:
 !MESSAGE
@@ -49,10 +60,29 @@ INTDIR=.\Release
 !endif
 REFDOCDIR=../../../doc/src/sgml/ref
 
+CPP_PROJ = -I$(BCB)\include;..\..\include;..\..\interfaces\libpq;..\..\include\port\win32 \
+           -c -D$(USERDEFINES) -DFRONTEND -n"$(INTDIR)" -tWM -tWC -q -5 -a8 -pc -X -w-use \
+	   -w-par -w-pia -w-csu -w-aus -w-ccc
+
+!IFDEF DEBUG
+CPP_PROJ  	= $(CPP_PROJ) -Od -r- -k -v -y -vi- -D_DEBUG
+LIBPG_DIR 	= Debug
+!ELSE
+CPP_PROJ	= $(CPP_PROJ) -O -Oi -OS -DNDEBUG
+LIBPG_DIR 	= Release
+!ENDIF
+
+!IFDEF DLL_LIBS
+CPP_PROJ	= $(CPP_PROJ) -D_RTLDLL
+LIBRARIES	= cw32mti.lib ..\..\interfaces\libpq\$(LIBPG_DIR)\blibpqdll.lib
+!ELSE
+CPP_PROJ	= $(CPP_PROJ) -DBCC32_STATIC
+LIBRARIES	= cw32mt.lib ..\..\interfaces\libpq\$(LIBPG_DIR)\blibpq.lib
+!ENDIF
+
 .path.obj = $(INTDIR)
 
-.c.obj:
-	$(CPP) -o"$(INTDIR)\$&" $(CPP_PROJ) $<
+USERDEFINES = WIN32;_CONSOLE;_MBCS;HAVE_STRDUP
 
 ALL : sql_help.h psqlscan.c "..\..\port\pg_config_paths.h" "$(OUTDIR)\psql.exe"
 
@@ -86,68 +116,51 @@ CLEAN :
 	-@erase "$(OUTDIR)\psql.exe"
 	-@erase "$(INTDIR)\..\..\port\pg_config_paths.h"
 
-"..\..\port\pg_config_paths.h": win32.mak
-	echo #define PGBINDIR "" >$@
-	echo #define PGSHAREDIR "" >>$@
-	echo #define SYSCONFDIR "" >>$@
-	echo #define INCLUDEDIR "" >>$@
-	echo #define PKGINCLUDEDIR "" >>$@
-	echo #define INCLUDEDIRSERVER "" >>$@
-	echo #define LIBDIR "" >>$@
-	echo #define PKGLIBDIR "" >>$@
-	echo #define LOCALEDIR "" >>$@
-
-"$(OUTDIR)" :
-    if not exist "$(OUTDIR)/$(NULL)" mkdir "$(OUTDIR)"
-
-USERDEFINES = WIN32;_CONSOLE;_MBCS;HAVE_STRDUP
-
-# ---------------------------------------------------------------------------
-CPP_PROJ = -I$(BCB)\include;..\..\include;..\..\interfaces\libpq;..\..\include\port\win32 \
-           -c -D$(USERDEFINES) -DFRONTEND -tWM -tWC -q -5 -a8 -pc -X -w-use -w-par -w-pia \
-	   -w-csu -w-aus -w-ccc
+LINK32=ilink32.exe
+LINK32_FLAGS=-L$(BCB)\lib;.\$(LIBPG_DIR) -x -v
+LINK32_OBJS= \
+	"$(INTDIR)\command.obj" \
+	"$(INTDIR)\common.obj" \
+	"$(INTDIR)\copy.obj" \
+	"$(INTDIR)\describe.obj" \
+	"$(INTDIR)\help.obj" \
+	"$(INTDIR)\input.obj" \
+	"$(INTDIR)\large_obj.obj" \
+	"$(INTDIR)\mainloop.obj" \
+	"$(INTDIR)\mbprint.obj" \
+	"$(INTDIR)\print.obj" \
+	"$(INTDIR)\prompt.obj" \
+	"$(INTDIR)\psqlscan.obj" \
+	"$(INTDIR)\startup.obj" \
+	"$(INTDIR)\stringutils.obj" \
+	"$(INTDIR)\tab-complete.obj" \
+	"$(INTDIR)\variables.obj" \
+	"$(INTDIR)\exec.obj" \
+	"$(INTDIR)\getopt.obj" \
+	"$(INTDIR)\getopt_long.obj" \
+	"$(INTDIR)\path.obj" \
+	"$(INTDIR)\pgstrcasecmp.obj" \
+	"$(INTDIR)\sprompt.obj"
 
 !IFDEF DEBUG
-CPP_PROJ  	= $(CPP_PROJ) -Od -r- -k -v -y -vi- -D_DEBUG
-LIBPG_DIR 	= Debug
+LINK32_OBJS	= $(LINK32_OBJS) "..\..\interfaces\libpq\Debug\blibpqddll.lib"
 !ELSE
-CPP_PROJ	= $(CPP_PROJ) -O -Oi -OS -DNDEBUG
-LIBPG_DIR 	= Release
+LINK32_OBJS	= $(LINK32_OBJS) "..\..\interfaces\libpq\Release\blibpqdll.lib"
 !ENDIF
 
-!IFDEF DLL_LIBS
-CPP_PROJ	= $(CPP_PROJ) -D_RTLDLL
-LIBRARIES	= cw32mti.lib ..\..\interfaces\libpq\$(LIBPG_DIR)\blibpqdll.lib
-!ELSE
-CPP_PROJ	= $(CPP_PROJ) -DBCC32_STATIC
-LIBRARIES	= cw32mt.lib ..\..\interfaces\libpq\$(LIBPG_DIR)\blibpq.lib
-!ENDIF
+"..\..\port\pg_config_paths.h": win32.mak
+	echo \#define PGBINDIR "" >$@
+	echo \#define PGSHAREDIR "" >>$@
+	echo \#define SYSCONFDIR "" >>$@
+	echo \#define INCLUDEDIR "" >>$@
+	echo \#define PKGINCLUDEDIR "" >>$@
+	echo \#define INCLUDEDIRSERVER "" >>$@
+	echo \#define LIBDIR "" >>$@
+	echo \#define PKGLIBDIR "" >>$@
+	echo \#define LOCALEDIR "" >>$@
 
-LINK32=ilink32.exe
-LINK32_FLAGS=-L$(BCB)\lib;.\$(LIBPG_DIR) -x -v 
-LINK32_OBJS= \
-	command.obj \
-	common.obj \
-	copy.obj \
-	describe.obj \
-	help.obj \
-	input.obj \
-	large_obj.obj \
-	mainloop.obj \
-	mbprint.obj
-	print.obj \
-	prompt.obj \
-	startup.obj \
-	stringutils.obj \
-	tab-complete.obj \
-	variables.obj \
-	exec.obj \
-	getopt.obj \
-	getopt_long.obj \
-	path.obj \
-	pgstrcasecmp.obj \
-	sprompt.obj \
-	
+"$(OUTDIR)" :
+    if not exist "$(OUTDIR)/$(NULL)" mkdir "$(OUTDIR)"
 
 "$(OUTDIR)\psql.exe" : "$(OUTDIR)" $(LINK32_OBJS)
 	$(LINK32) @&&!
@@ -157,15 +170,42 @@ LINK32_OBJS= \
 	import32.lib $(LIBRARIES),,
 !
 
-exec.obj : "$(OUTDIR)" ..\..\port\exec.c
-getopt.obj : "$(OUTDIR)" ..\..\port\getopt.c
-getopt_long.obj : "$(OUTDIR)" ..\..\port\getopt_long.c
-path.obj : "$(OUTDIR)" ..\..\port\path.c
-pgstrcasecmp.obj : "$(OUTDIR)" ..\..\port\pgstrcasecmp.c
-sprompt.obj : "$(OUTDIR)" ..\..\port\sprompt.c
+"$(INTDIR)\exec.obj" : ..\..\port\exec.c
+    $(CPP) @<<
+    $(CPP_PROJ) ..\..\port\exec.c
+<<
+
+"$(INTDIR)\getopt.obj" : "$(INTDIR)" ..\..\port\getopt.c
+    $(CPP) @<<
+    $(CPP_PROJ) ..\..\port\getopt.c
+<<
+
+"$(INTDIR)\getopt_long.obj" : "$(INTDIR)" ..\..\port\getopt_long.c
+    $(CPP) @<<
+    $(CPP_PROJ) ..\..\port\getopt_long.c
+<<
+
+"$(INTDIR)\path.obj" : "$(INTDIR)" ..\..\port\path.c
+    $(CPP) @<<
+    $(CPP_PROJ) ..\..\port\path.c
+<<
+
+"$(INTDIR)\pgstrcasecmp.obj" : ..\..\port\pgstrcasecmp.c
+    $(CPP) @<<
+    $(CPP_PROJ) ..\..\port\pgstrcasecmp.c
+<<
+
+"$(INTDIR)\sprompt.obj" : "$(INTDIR)" ..\..\port\sprompt.c
+    $(CPP) @<<
+    $(CPP_PROJ) ..\..\port\sprompt.c
+<<
 
 "sql_help.h": create_help.pl 
        $(PERL) create_help.pl $(REFDOCDIR) $@
 
 psqlscan.c : psqlscan.l
 	$(FLEX) -Cfe -opsqlscan.c psqlscan.l
+
+.c.obj:
+	$(CPP) -o"$(INTDIR)\$&" $(CPP_PROJ) $<
+
diff --git a/src/bin/psql/win32.mak b/src/bin/psql/win32.mak
index 64dd1ff..ad2ba7c 100644
--- a/src/bin/psql/win32.mak
+++ b/src/bin/psql/win32.mak
@@ -79,7 +79,7 @@ CPP_SBRS=.
 
 LINK32=link.exe
 LINK32_FLAGS=kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib\
- advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib\
+ advapi32.lib shfolder.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib\
  odbccp32.lib wsock32.lib /nologo /subsystem:console /incremental:no\
  /pdb:"$(OUTDIR)\psql.pdb" /machine:I386 $(LOPT) /out:"$(OUTDIR)\psql.exe" 
 LINK32_OBJS= \
@@ -146,18 +146,15 @@ LINK32_OBJS= \
     $(CPP_PROJ) ..\..\port\sprompt.c
 <<
 
+sql_help.h : create_help.pl
+        $(PERL) create_help.pl $(REFDOCDIR) $@
+	
+psqlscan.c: psqlscan.l
+	$(FLEX) -Cfe -opsqlscan.c psqlscan.l
+
 .c{$(CPP_OBJS)}.obj::
    $(CPP) @<<
    $(CPP_PROJ) $< 
 <<
 
-.cpp{$(CPP_OBJS)}.obj::
-   $(CPP) @<<
-   $(CPP_PROJ) $< 
-<<
 
-sql_help.h : create_help.pl
-        $(PERL) create_help.pl $(REFDOCDIR) $@
-	
-psqlscan.c: psqlscan.l
-	$(FLEX) -Cfe -opsqlscan.c psqlscan.l
diff --git a/src/bin/scripts/Makefile b/src/bin/scripts/Makefile
index 83a319b..15b4e0c 100644
--- a/src/bin/scripts/Makefile
+++ b/src/bin/scripts/Makefile
@@ -21,7 +21,7 @@ override CPPFLAGS := -DFRONTEND -I$(top_srcdir)/src/bin/pg_dump -I$(top_srcdir)/
 all: submake-libpq submake-backend $(PROGRAMS)
 
 %: %.o $(WIN32RES)
-	$(CC) $(CFLAGS) $^ $(libpq) $(LDFLAGS) $(LIBS) -o $@$(X)
+	$(CC) $(CFLAGS) $^ $(libpq_pgport) $(LDFLAGS) $(LIBS) -o $@$(X)
 
 createdb: createdb.o common.o dumputils.o $(top_builddir)/src/backend/parser/keywords.o
 createlang: createlang.o common.o print.o mbprint.o
diff --git a/src/include/catalog/pg_aggregate.h b/src/include/catalog/pg_aggregate.h
index 2090a7e..f08246a 100644
--- a/src/include/catalog/pg_aggregate.h
+++ b/src/include/catalog/pg_aggregate.h
@@ -19,6 +19,8 @@
 #ifndef PG_AGGREGATE_H
 #define PG_AGGREGATE_H
 
+#include "nodes/pg_list.h"
+
 /* ----------------
  *		postgres.h contains the system type definitions and the
  *		CATALOG(), BOOTSTRAP and DATA() sugar words so this file
diff --git a/src/include/commands/dbcommands.h b/src/include/commands/dbcommands.h
index f341e65..85e0ed9 100644
--- a/src/include/commands/dbcommands.h
+++ b/src/include/commands/dbcommands.h
@@ -18,22 +18,47 @@
 #include "nodes/parsenodes.h"
 
 /* XLOG stuff */
-#define XLOG_DBASE_CREATE		0x00
-#define XLOG_DBASE_DROP			0x10
+#define XLOG_DBASE_CREATE_OLD	0x00
+#define XLOG_DBASE_DROP_OLD		0x10
+#define XLOG_DBASE_CREATE		0x20
+#define XLOG_DBASE_DROP			0x30
 
-typedef struct xl_dbase_create_rec
+/*
+ * Note: "old" versions are deprecated and need not be supported beyond 8.0.
+ * Not only are they relatively bulky, but they do the Wrong Thing when a
+ * WAL log is replayed in a data area that's at a different absolute path
+ * than the original.
+ */
+
+typedef struct xl_dbase_create_rec_old
 {
 	/* Records copying of a single subdirectory incl. contents */
 	Oid			db_id;
 	char		src_path[1];	/* VARIABLE LENGTH STRING */
 	/* dst_path follows src_path */
+}	xl_dbase_create_rec_old;
+
+typedef struct xl_dbase_drop_rec_old
+{
+	/* Records dropping of a single subdirectory incl. contents */
+	Oid			db_id;
+	char		dir_path[1];	/* VARIABLE LENGTH STRING */
+}	xl_dbase_drop_rec_old;
+
+typedef struct xl_dbase_create_rec
+{
+	/* Records copying of a single subdirectory incl. contents */
+	Oid			db_id;
+	Oid			tablespace_id;
+	Oid			src_db_id;
+	Oid			src_tablespace_id;
 }	xl_dbase_create_rec;
 
 typedef struct xl_dbase_drop_rec
 {
 	/* Records dropping of a single subdirectory incl. contents */
 	Oid			db_id;
-	char		dir_path[1];	/* VARIABLE LENGTH STRING */
+	Oid			tablespace_id;
 }	xl_dbase_drop_rec;
 
 extern void createdb(const CreatedbStmt *stmt);
diff --git a/src/include/executor/nodeAgg.h b/src/include/executor/nodeAgg.h
index 88e394b..5fd601a 100644
--- a/src/include/executor/nodeAgg.h
+++ b/src/include/executor/nodeAgg.h
@@ -23,6 +23,8 @@ extern TupleTableSlot *ExecAgg(AggState *node);
 extern void ExecEndAgg(AggState *node);
 extern void ExecReScanAgg(AggState *node, ExprContext *exprCtxt);
 
+extern Size hash_agg_entry_size(int numAggs);
+
 extern Datum aggregate_dummy(PG_FUNCTION_ARGS);
 
 #endif   /* NODEAGG_H */
diff --git a/src/include/optimizer/clauses.h b/src/include/optimizer/clauses.h
index 124f859..8609a63 100644
--- a/src/include/optimizer/clauses.h
+++ b/src/include/optimizer/clauses.h
@@ -17,11 +17,17 @@
 #include "nodes/relation.h"
 
 
-
 #define is_opclause(clause)		((clause) != NULL && IsA(clause, OpExpr))
 #define is_funcclause(clause)	((clause) != NULL && IsA(clause, FuncExpr))
 #define is_subplan(clause)		((clause) != NULL && IsA(clause, SubPlan))
 
+typedef struct
+{
+	int			numAggs;			/* total number of aggregate calls */
+	int			numDistinctAggs;	/* number that use DISTINCT */
+	Size		transitionSpace;	/* for pass-by-ref transition data */
+} AggClauseCounts;
+
 
 extern Expr *make_opclause(Oid opno, Oid opresulttype, bool opretset,
 			  Expr *leftop, Expr *rightop);
@@ -42,8 +48,7 @@ extern Expr *make_ands_explicit(List *andclauses);
 extern List *make_ands_implicit(Expr *clause);
 
 extern bool contain_agg_clause(Node *clause);
-extern bool contain_distinct_agg_clause(Node *clause);
-extern int	count_agg_clause(Node *clause);
+extern void count_agg_clauses(Node *clause, AggClauseCounts *counts);
 
 extern bool expression_returns_set(Node *clause);
 
diff --git a/src/include/optimizer/paths.h b/src/include/optimizer/paths.h
index 3a91886..2280c4d 100644
--- a/src/include/optimizer/paths.h
+++ b/src/include/optimizer/paths.h
@@ -114,6 +114,7 @@ extern List *build_subquery_pathkeys(Query *root, RelOptInfo *rel,
 						Query *subquery);
 extern List *build_join_pathkeys(Query *root,
 					RelOptInfo *joinrel,
+					JoinType jointype,
 					List *outer_pathkeys);
 extern List *make_pathkeys_for_sortclauses(List *sortclauses,
 							  List *tlist);
diff --git a/src/include/port/win32.h b/src/include/port/win32.h
index a3b2ddb..3a3dc1e 100644
--- a/src/include/port/win32.h
+++ b/src/include/port/win32.h
@@ -17,6 +17,7 @@
 
 
 #define fsync(a)	_commit(a)
+#define FSYNC_IS_WRITE_THROUGH
 #define ftruncate(a,b)	chsize(a,b)
 
 #define USES_WINSOCK
@@ -184,6 +185,14 @@ typedef int pid_t;
 #define lstat(path, sb)	stat((path), (sb))
 
 /*
+ * Supplement to <fcntl.h>.
+ * This is the same value as _O_NOINHERIT in the MS header file. This is
+ * to ensure that we don't collide with a future definition. It means
+ * we cannot use _O_NOINHERIT ourselves.
+ */
+#define O_DSYNC 0x0080
+
+/*
  * Supplement to <errno.h>.
  */
 #undef EAGAIN
